-- Cruise Control Addon
--
-- Version 1.0
-- Autor: Kryster
-- 
-- Change log:
-- 07/27/2017 Release 1.0


ccaddon_Register = {};

if SpecializationUtil.specializations["ccaddon"] == nil then
	SpecializationUtil.registerSpecialization("ccaddon", "ccaddon", g_currentModDirectory.."CCAddon.lua")
	ccaddon_Register.isLoaded = false;
end;


function ccaddon_Register:loadMap(name)
	print("[CCAddon] Registering specializations")
	if self.firstRun == nil then
		self.firstRun = false;
		for _, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("drivable")then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.ccaddon", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then	
							table.insert(v.specializations, SpecializationUtil.getSpecialization("ccaddon"));
							print("[CCAddon] Installing script into " .. v.name)
						end;
					end;
				end;
			end;	
		end;
	end;	
end;


function ccaddon_Register:deleteMap()
  
end;

function ccaddon_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function ccaddon_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function ccaddon_Register:update(dt)
	
end;

function ccaddon_Register:draw()
end;

addModEventListener(ccaddon_Register);